<template>
    <div :class="$style.container">
        <progress :value="progress" max="100"></progress>
        {{progress.toFixed(2)}}% to your birthday!
        <h1>Hi {{state.user.name}}! we're glad that you have {{daysToBday}} days until your birthday!. We'll send a message to {{state.user.email}}</h1>
        <form :class="$style.form">
            <fieldset>
                <legend>Personalia:</legend>Name:
                <input type="text" v-model="state.user.name" />
                <br />Email:
                <input type="email" v-model="state.user.email" />
                <br />Date of birth:
                <input
                    type="date"
                    v-model="state.user.birthDate"
                    :min="moment().add(1,'days').format('YYYY-MM-DD')"
                    :max="moment().add(1, 'years').format('YYYY-MM-DD')"
                />
            </fieldset>
        </form>

        <textarea rows="4" cols="50" v-model="state.area" />
        <details>
            <summary>Copyright 1999-{{ moment().format("YYYY") }}.</summary>
            <p>- by Refsnes Data. All Rights Reserved.</p>
            <p>All content and graphics on this web site are the property of the company Refsnes Data.</p>
        </details>
    </div>
</template>

<script lang="ts">
import { createComponent, reactive, computed, watch } from "@vue/composition-api";
import moment, { Moment } from "moment";
export default createComponent({
    setup() {
        const state = reactive({
            area: "",
            user: {
                name: "Adrian",
                email: "TsukugiXIII@gmail.com",
                birthDate: `${moment().format("YYYY")}-08-30`,
            },
            range: 365,
        });

        const daysToBday = computed(() => (state.user.birthDate ? moment(state.user.birthDate).diff(moment(), "day") : 0));

        const progress = computed(() => {
            if (daysToBday.value > 0 && daysToBday.value <= state.range) {
                return 100 - (daysToBday.value * 100) / 365;
            } else {
                return 0;
            }
        });
        return { state, moment, progress, daysToBday };
    },
});
</script>

<style lang="scss" module>
.container {
    border: 2px solid limegreen;
    display: flex;
    flex-direction: column;
    align-items: center;
    .form {
        width: 15vw;
    }
}
</style>